package rs.dmi.master.component.edge;

import java.util.List;
import java.util.Map;

import rs.dmi.master.component.AbstractComponentCollection;
import rs.dmi.master.component.vertex.Vertex;

/**
 * Collection of edges.
 * 
 * @author niktrk
 * @date 20.10.2012.
 * 
 */
public class EdgeCollection extends AbstractComponentCollection<Edge> {

	public EdgeCollection() {
		super();
	}

	public EdgeCollection(String bitset) {
		super(bitset);
	}

	public EdgeCollection(EdgeCollection edgeCollection) {
		super(edgeCollection);
	}

	public EdgeCollection(List<Integer> vertexPath) {
		this();
		for (int i = 1; i < vertexPath.size(); i++) {
			add(Edge.EDGES[vertexPath.get(i - 1)][vertexPath.get(i)]);
		}
	}

	public boolean contains(Vertex first, Vertex second) {
		return contains(Edge.EDGES[first.getIndex()][second.getIndex()]);
	}

	@Override
	protected Map<Long, Edge> getBitComponentMap() {
		return Edge.EDGES_BITMAP;
	}

}
