package rs.dmi.master.game.hamiltonian.setbased;

import java.util.HashSet;
import java.util.Set;

import rs.dmi.master.component.edge.EdgeCollection;
import rs.dmi.master.game.GamePlay;
import rs.dmi.master.game.Player;
import rs.dmi.master.game.base.AbstractSetPathCollectionGame;
import rs.dmi.master.game.hamiltonian.HamiltonianPathCalculator;
import rs.dmi.master.lookuptable.LookupTable;
import rs.dmi.master.lookuptable.TLongSetMapLookupTable;
import rs.dmi.master.pathcollection.AbstractSetPathCollection;
import rs.dmi.master.pathcollection.PathCollection;
import rs.dmi.master.pathcollection.SetPathCollection;

/**
 * Hamiltonian cycle game based on {@link AbstractSetPathCollection}
 * implementation.
 * 
 * @author niktrk
 * @date 05.02.2014.
 * 
 */
public class HamiltonianCycleGameSetBased extends AbstractSetPathCollectionGame {

	public HamiltonianCycleGameSetBased(int size, GamePlay gamePlay, LookupTable lookup, int depth, AbstractSetPathCollection pathCollection) {
		super(size, gamePlay, lookup, depth, pathCollection);
	}

	@Override
	protected int getMinimumNumberOfEdgesForMakerWin(int numberOfVertices) {
		return numberOfVertices;
	}

	@Override
	protected void calculatePaths(int numberOfVertices, PathCollection<Set<EdgeCollection>> cycleCollection) {
		HamiltonianPathCalculator.INSTANCE.getCycles(numberOfVertices, cycleCollection);
	}

	public static void main(String[] args) {
		HamiltonianCycleGameSetBased game = new HamiltonianCycleGameSetBased(7, new GamePlay(Player.MAKER, 1, 1), new TLongSetMapLookupTable(), 15,
				new SetPathCollection(HashSet.class));
		game.playTheGame();
	}
}
