package rs.dmi.master.game.hamiltonian.setbased;

import java.util.LinkedHashSet;
import java.util.Set;

import rs.dmi.master.component.edge.EdgeCollection;
import rs.dmi.master.game.GamePlay;
import rs.dmi.master.game.Player;
import rs.dmi.master.game.base.AbstractSetPathCollectionGame;
import rs.dmi.master.game.hamiltonian.HamiltonianPathCalculator;
import rs.dmi.master.lookuptable.BasicLookupTable;
import rs.dmi.master.lookuptable.LookupTable;
import rs.dmi.master.pathcollection.AbstractSetPathCollection;
import rs.dmi.master.pathcollection.PathCollection;
import rs.dmi.master.pathcollection.SetPathCollection;

/**
 * Hamiltonian path game based on {@link AbstractSetPathCollection}
 * implementation.
 * 
 * @author niktrk
 * @date 05.02.2014.
 * 
 */
public class HamiltonianPathGameSetBased extends AbstractSetPathCollectionGame {

	public HamiltonianPathGameSetBased(int size, GamePlay gamePlay, LookupTable lookup, AbstractSetPathCollection pathCollection) {
		super(size, gamePlay, lookup, pathCollection);
	}

	@Override
	protected int getMinimumNumberOfEdgesForMakerWin(int numberOfVertices) {
		return numberOfVertices - 1;
	}

	@Override
	protected void calculatePaths(int numberOfVertices, PathCollection<Set<EdgeCollection>> pathCollection) {
		HamiltonianPathCalculator.INSTANCE.getPaths(numberOfVertices, pathCollection);
	}

	public static void main(String[] args) {
		HamiltonianPathGameSetBased game = new HamiltonianPathGameSetBased(5, new GamePlay(Player.MAKER, 1, 1), new BasicLookupTable(),
				new SetPathCollection(LinkedHashSet.class));
		game.playTheGame();
	}

}
