package rs.dmi.master.lookuptable;

import java.util.HashMap;
import java.util.Map;

import rs.dmi.master.game.Player;
import rs.dmi.master.isomorphism.GameGraphState;

/**
 * Basic lookup using {@link HashMap}.
 * 
 * @author niktrk
 * @date 01.01.2013.
 * 
 */
public class BasicLookupTable implements LookupTable {

	private Map<Long, Map<Long, Player>> lookup;
	private Map<Long, Player> temp;

	public BasicLookupTable() {
		super();
		lookup = new HashMap<Long, Map<Long, Player>>();
	}

	@Override
	public Player getWinner(GameGraphState gameGraphState) {
		temp = lookup.get(gameGraphState.getMakersEdges().getBitset());
		if (temp != null) {
			return temp.get(gameGraphState.getBreakersEdges().getBitset());
		}
		return null;
	}

	@Override
	public void setWinner(GameGraphState gameGraphState, Player winner) {
		temp = lookup.get(gameGraphState.getMakersEdges().getBitset());
		if (temp == null) {
			temp = new HashMap<Long, Player>();
			lookup.put(gameGraphState.getMakersEdges().getBitset(), temp);
		}
		temp.put(gameGraphState.getBreakersEdges().getBitset(), winner);
	}

}
