package rs.dmi.master.pathcollection;

import rs.dmi.master.component.edge.Edge;
import rs.dmi.master.component.edge.EdgeCollection;

/**
 * Interface for path collection classes.
 * 
 * @author niktrk
 * @date 24.01.2014.
 * 
 * @param <T>
 *            - base type used for actual storage of path collection
 */
public interface PathCollection<T> {

	void addPathCollection(T pathCollection);

	T removeAllPathsWithEdge(Edge edge);

	void addPath(EdgeCollection edgeCollection);

	boolean containsSubsetOf(EdgeCollection edgeCollection);

	boolean containsOrWillContainSubsetOf(EdgeCollection edgeCollection, EdgeCollection graphFreeEdges, Edge lastAddedEdge);

	boolean isEmpty();

	int size();

}
